#include "config.h"
#include "dt.h"




void WriteVia(FILE *F)
{
 struct tm *tm;
 time_t t;
 t = time(0);
 tm = gmtime (&t);
 fprintf(F,"\x0D\x01Via %u:%u/%u.%u @%04u%02u%02u.%02u%02u%02u GMT %s/%s/%s\n",MYZONE,MYNET,MYNODE,MYPOINT,
   1900+tm->tm_year,tm->tm_mon+1,tm->tm_mday, tm->tm_hour,tm->tm_min,tm->tm_sec,
   shortname,ver,MYOS);   
}

#ifdef _LOCAL_KOI8
ConvertLine(char *linee,unsigned char *table)
{
 unsigned char *c;
 int i;
 for (i=0;i<strlen(linee);i++)
  if (linee[i]&0x80)
   linee[i] = table[linee[i]&0x7F];
}

#define line2KOI(x) ConvertLine(x,alt2koi8)
#define line2ALT(x) ConvertLine(x,koi82alt)

void toKOI(internal_message *m)
{
 line2KOI(m->SSubj);
 line2KOI(m->FFrom);
 line2KOI(m->TTo);
 line2KOI(m->Text);
}
void toALT(internal_message *m)
{
 line2ALT(m->SSubj);
 line2ALT(m->FFrom);
 line2ALT(m->TTo);
 line2ALT(m->Text);
}
#endif /* local loi8 */

long filelength(FILE *F)
{
 long i;
 //fseek(F,0L,SEEK_END); 
 //i = ftell(F);
 i = lseek(fileno(F),0L,SEEK_END);
 printf("%lu bytes\n",i);
 lseek(fileno(F),0L,SEEK_SET);
 return(i);
}


clear_message(internal_message *m1,char force)
{
 if (force)    
 {
  if (m1->Text != NULL)
  {
   free(m1->Text);m1->Text = NULL;
  }
  m1->Ozone=m1->Onet=m1->Onode=m1->Opoint=0;
  m1->Dzone=m1->Dnet=m1->Dnode=m1->Dpoint=0;
  *(m1->Areatag) =  *(m1->FFrom) = *(m1->TTo) = *(m1->SSubj) = 0;
 }
}

/************************* Writes Message to Folder *************************/
/* This procedure has two purposes. Given by a DIRECTORY name (which ends)
** by SLASH, it creates a new message in directory.
** But given an absoulute name, it doesnt create new, but saves with
** given name (possibly overwriting existing message)
*/
char write_message_to_folder(internal_message *m,char *areaname,char mode)
{
 int maxmsgg;
 char msgname[FILENAME_MAX];
 FILE *msg;
 char storedmsghdr[0xBE];
 short i;

// printf("Last qq %c",areaname[strlen(areaname)-1]);
// if (areaname[strlen(areaname)-1] == SLASH)
 if (!mode)
 {
  //  printf("+Writing message to folder\n");
  /* generating message name */
  maxmsgg=maximal_message(areaname);
  // printf("Max message number is %u\n",maxmsgg);
  maxmsgg++;
  // printf("We'll write %u\n",maxmsgg);

  sprintf(msgname,"%s%s%c%u.msg",ECHOROOT,areaname,SLASH,maxmsgg);
  // printf(": [%s]:%u\n",areaname,maxmsgg);
 #ifndef _UNIX_FILES
  msg = _fsopen(msgname,"wb",SH_DENYNO);
 #else
  msg = fopen(msgname,"w");
 #endif
  if (!msg) /* if we fail to write to folder - lets write to badmail */
  {
   printf("!Cant write message to %s - tossing to BADMAIL\n",msgname);
//  sprintf(msgname,"%s%s/%u.msg",ECHOROOT,BADMAIL,badmails+1);
   sprintf(msgname,"%s%s/%u.msg",ECHOROOT,BADMAIL,badmails = maximal_message(BADMAIL));
 //  strcpy(areaname,BADMAIL);
 #ifndef _UNIX_FILES
   msg = _fsopen(msgname,"wb",SH_DENYNO);
 #else
   msg = fopen(msgname,"w");
 #endif
   if (msg) badmails ++;
   maxmsgg = badmails;
   t_bad ++;
  }
  else
   t_good ++;
 }else /* we've been given not areafolder, but a FILENAME*/
 {
  //  printf("+Writing message to file [%s]\n",areaname);
 #ifndef _UNIX_FILES
   msg = _fsopen(areaname,"wb",SH_DENYNO);
 #else
   msg = fopen(areaname,"w");
 #endif
 }
 /* Yes, we have opened message somewhere in (echoes, badmail) */
 if (msg)
 {
  strcpy(storedmsghdr,m->FFrom);storedmsghdr[0x23]=0;
  strcpy(storedmsghdr+0x24,m->TTo);storedmsghdr[0x47]=0;
  strcpy(storedmsghdr+0x48,m->SSubj);storedmsghdr[0x8F]=0;
  strncpy(storedmsghdr+0x90,m->DDate,20);
  *(short *)(storedmsghdr+0xA6) = m->Dnode; /* destnode */
  *(short *)(storedmsghdr+0xA8) = m->Onode; /* orignode */
  *(short *)(storedmsghdr+0xAE) = m->Dnet; /* destnet */
  *(short *)(storedmsghdr+0xAC) = m->Onet;/* orignet */
  *(short *)(storedmsghdr+0xBA) = m->Attr;/* attribute */
  *(short *)(storedmsghdr+0xAA) = 0 ;/* cost */
    fwrite(storedmsghdr,1,0xBE,msg);
// looks like a bug. DummyTosser writes AREA: in echomail messages
  if (!strncmp(m->Text,"AREA",4))
  {
   // Skip "AREA"
   for (i=4;(i<128)&&(*((m->Text) + i)>= 32)&&(*((m->Text) + i)< 128);i++);
   // Skip line terminator (cr,lf - do not care)
   while ((*((m->Text)+i)) &&
         ((*((m->Text)+i)=='\n')||(*((m->Text)+i)=='\r'))
	) i++;
   fputs((m->Text)+i,msg);
  }else
  {
   fputs(m->Text,msg);
  }
  putc(0,msg); /* writing END OF Message Sign*/
  fclose(msg); /* Done */
  return(0);
 }else
 {
  printf("Cant write message even in BADMAIL [%s],sux!\n",msgname);
  return(2);
 }
}


/************************* Reads Message from *.msg *************************/
char read_message_from_msg(internal_message *m,char *msgname,char *AREATAG)
{
 long msglength;
 int i,i1;
 FILE *msg;
 char storedmsghdr[0xBE];

 if (access(msgname,W_OK)) 
 {
  printf("!Warning: I will not able to write %s back - skipping send\n",msgname);
  return(1);
 }
#ifndef _UNIX_FILES
 msg = _fsopen(msgname,"rb",SH_DENYNO);
#else
 msg = fopen(msgname,"r");
#endif
 // printf("Msg handle [%u]\n",fileno(msg));
 if (!msg)
 {
   printf("!Cannot open message [%s]\n",msgname);
  return(1);
 }
 //printf("fseek result [%d]\n",fseek(msg,0L,SEEK_END));
 
 //msglength = filelength(msg);
 lseek(fileno(msg),0L,SEEK_END);
 msglength = ftell(msg);
 lseek(fileno(msg),0L,SEEK_SET);
 //fseek(msg,0L,SEEK_SET);

 if(msglength < (unsigned long)0xBE)
 {
  printf("!Invalid .msg[%s],(length just %lu),suxx!\n",msgname,msglength);
  fclose(msg);
  return(1);
 }

 fread(storedmsghdr,1,0xBE,msg);

 strncpy(m->FFrom,storedmsghdr,0x24);m->FFrom[0x23]=0;
 strncpy(m->TTo,storedmsghdr+0x24,0x24);m->TTo[0x23]=0;
 strncpy(m->SSubj,storedmsghdr+0x48,0x48);m->SSubj[0x8F]=0;
 strncpy(m->DDate,storedmsghdr+0x90,20);
 m->Dnode = *(short *)(storedmsghdr+0xA6); /* destnode */
 m->Onode = *(short *)(storedmsghdr+0xA8); /* orignode */
 m->Dnet = *(short *)(storedmsghdr+0xAE); /* destnet */
 m->Onet = *(short *)(storedmsghdr+0xAC); /* orignet */
 m->Attr = *(short *)(storedmsghdr+0xBA);/* attribute */
 // printf("Allocating %d bytes",msglength - 0xBE);
 m->Text = malloc(msglength - 0xBE);

 if (!(m->Text))
 {
  printf("!Cannot load message to memory,Suxx!\n");
  fclose(msg);
  return(1);
 }
 fread(m->Text,1,msglength - 0xBE,msg);
 // Golded is fucking, fucking, fucking! it doesnt write AREA: in message
 // it creates. Pitty thing if I find that timed (or someone else) DOES IT.
 // i = 0;  while ( ((m->Text[i])==0x0D) || ((m->Text[i])==0x0A) ) i++;
 //if (!strncmp( (m->Text) + i,"AREA: ",5))
 if(strcmp(AREATAG,"NETMAIL"))
 {
   i1 = 0;
   //   for (i += 5;(m->Text[i + i1]) > ' ';i1++);
   //printf("Areatag length is {%u}",i1);
   //strcpy(m->Areatag,(m->Text)+i,i1);
   //m->Areatag[i1] = 0;
   strcpy(m->Areatag,AREATAG);
   m->echomail = 1;
 }else
 {
   strcpy(m->Areatag,"NETMAIL");
   m->echomail = 0;
 }
 fclose(msg);
 return(0);
}


/* like fgets, but separator can be not only 0x0d */
char *fgetsplus(kyda,ckoko,F,separator)
char *kyda;int ckoko;FILE *F;char separator;
{
 int c,i;
 i = 0;
 while ( ((c=fgetc(F)) != EOF) && (c!=separator) && (i < ckoko))  *(kyda+(i++)) = (char) c;
 *(kyda+i) = 0;
 return(kyda);
}

char write_message_to_pkt(internal_message *m,FILE *pkt)
{ 
 unsigned char pmsghdr[0x22];
 #ifdef _LOCAL_KOI8
 toALT(m);
 #endif

 *(short *)(pmsghdr) = 2;
 *(short *)(pmsghdr+0x02) = m->Onode;
 *(short *)(pmsghdr+0x04) = m->Dnode;
 *(short *)(pmsghdr+0x06) = m->Onet;
 *(short *)(pmsghdr+0x08) = m->Dnet;
 *(short *)(pmsghdr+0x0A) = m->Attr;
 *(short *)(pmsghdr+0x0C) = 0;
 strncpy((char *)pmsghdr + 0x0E,m->DDate,20);
 fwrite(pmsghdr,1,0x22,pkt);
 fputs(m->TTo,pkt); fputc(0,pkt);
 fputs(m->FFrom,pkt); fputc(0,pkt);
 fputs(m->SSubj,pkt); fputc(0,pkt);
 if(m->echomail)
//fprintf(pkt,"AREA:%s\x0D",m->Areatag);
 {
  fputs("AREA:",pkt);
  fputs(m->Areatag,pkt);
  fputs("\x0D",pkt);
 }
 #ifndef _UPDATE_TEARLINE
  fputs(m->Text,pkt);
 #else
 {
  char *TAM;
  if( (TAM=strstr(m->Text,"\n---\n"))||
      (TAM=strstr(m->Text,"\r---\r")) ||
      (TAM=strstr(m->Text,"\r---\n")) ||
      (TAM=strstr(m->Text,"\n---\r")) ||
      (TAM=strstr(m->Text,"\r--- ")) ||
      (TAM=strstr(m->Text,"\n--- "))
    )
  {
   fwrite(m->Text,1,TAM-(m->Text)+4,pkt);
   fprintf(pkt," %s/%s/%s ",shortname,ver,MYOS);
   fputs(TAM+4,pkt);
  }else
  fputs(m->Text,pkt);  
 }
 #endif
 if (!(m->echomail))
   WriteVia(pkt);
 else
  fprintf(pkt,"SEEN-BY: %d/%d\x0D",MYNET,MYNODE);
 fputc(0,pkt);
 #ifdef _LOCAL_KOI8
 toKOI(m);
 #endif


}


